.\"
.\" "$Id: lp.man,v 1.1.1.1 2007-05-25 09:36:02 jick_nan Exp $"
.\"
.\"   lp/cancel man page for the Common UNIX Printing System (CUPS).
.\"
.\"   Copyright 1997-2002 by Easy Software Products.
.\"
.\"   These coded instructions, statements, and computer programs are the
.\"   property of Easy Software Products and are protected by Federal
.\"   copyright law.  Distribution and use rights are outlined in the file
.\"   "LICENSE.txt" which should have been included with this file.  If this
.\"   file is missing or damaged please contact Easy Software Products
.\"   at:
.\"
.\"       Attn: CUPS Licensing Information
.\"       Easy Software Products
.\"       44141 Airport View Drive, Suite 204
.\"       Hollywood, Maryland 20636-3111 USA
.\"
.\"       Voice: (301) 373-9603
.\"       EMail: cups-info@cups.org
.\"         WWW: http://www.cups.org
.\"
.TH lp 1 "Common UNIX Printing System" "25 Septembre 2001" "Easy Software Products"
.SH NOM
lp \- Imprime des fichiers
.br
cancel \- Annule des travaux d'impression
.SH SYNOPSIS
.B lp
[ -E ] [ \-c ] [ \-d
.I destination
] [ \-h
.I serveur
] [ \-m ] [ \-n
.I nb-copies
[ \-o
.I option
] [ \-q
.I priorit
] [ \-s ] [ \-t
.I titre
] [ \-H
.I mthode
] [ \-P
.I liste-de-pages
] [
.I fichier(s)
]
.br
.B lp
[ -E ] [ \-c ] [ \-h
.I serveur
] [ \-i
.I numro-de-travail
] [ \-n
.I nb-copies
[ \-o
.I option
] [ \-q
.I priorit
] [ \-t
.I titre
] [ \-H
.I mthode
] [ \-P
.I liste-de-pages
]
.br
.B cancel
[ \-a ] [ -h
.I serveur
] [
.I id
] [
.I destination
] [
.I destination-id
]
.SH DESCRIPTION
\fBlp\fR demande l'impression d'un fichier ou modifie un travail d'impression
en attente.
.LP
\fBcancel\fR annule un travail d'impression. L'option \fI-a\fR supprime tous
les travaux d'impression d'une destination.
.SH OPTIONS
Les options suivantes sont reconnues par \fBlp\fR\ :
.TP 5
\-E
.br
Force le cryptage des donnes lors de la connexion au serveur.
.TP 5
\-d \fIdestination\fR
.br
Imprime les fichiers sur l'imprimante donne.
.TP 5
\-h \fInom-de-machine\fR
.br
Demande l'impression sur un serveur d'impression donn. C'est par dfaut
\ localhost\  ou le contenu de la variable d'environnement CUPS_SERVER si
celle-ci existe.
.TP 5
\-i \fInumro-de-travail\fR
.br
Donne le numro du travail d'impression  modifier.
.TP 5
\-m
.br
Envoie un courrier lectronique lorsque l'impression est termine.
Cette option n'est pas gre par CUPS 1.1.
.TP 5
\-n \fInb-copies\fR
.br
Nombre de copies  effectuer (de 1  100).
.TP 5
\-o \fIoption\fR
.br
Dfinit une option pour le travail d'impression.
.TP 5
\-q \fIpriorit\fR
.br
Dfinit la priorit du travail d'impression, de 1 (minimale)  100 (maximale).
La priorit par dfaut est 50.
.TP 5
\-s
.br
N'affiche pas le numro du travail (mode silencieux).
.TP 5
\-t \fInom\fR
.br
Dfinit le nom du travail.
.TP 5
\-H \fImthode\fR
.br
Dfinit quand l'impression doit tre effectue. La valeur \fIimmediate\fR effectue
l'impression immdiatement, la valeur \fIhold\fR suspend l'impression indfiniment,
une valeur, une heure suspend l'impression jusqu' l'heure donne. Utilisez la valeur
\fIresume\fR avec l'option \fI-i\fR pour reprendre un travail suspendu.
.TP 5
\-P \fIliste-de-pages\fR
.br
Dfinit quelles sont les pages  imprimer. Cette liste ne peut contenir que des numros
ou des portions (#-#), spars par des virgules (ex\ : 1,3-5,16).
.SH COMPATIBILIT
Contrairement au systme d'impression System V, les imprimantes peuvent contenir n'importe
quel caractre imprimable sauf ESPACE et TABULATION. De mme, les noms d'imprimantes et de
classes ne sont pas sensibles  la casse.
.LP
L'option \ m\  n'est pas oprationnelle dans CUPS 1.1.
.LP
L'option \ q\  accepte des valeurs de 1  100, contrairement au lp de Solaris qui
utilise des valeurs de 0  39.
.SH VOIR AUSSI
lpstat(1),
CUPS Software Users Manual,
http://localhost:631/documentation.html
.SH COPYRIGHT
Copyright 1993-2002 Easy Software Products, Tous droits rservs.
.SH TRADUCTION
Gilles QUERRET <gilles.querret@nerim.net>
.\"
.\" End of "$Id: lp.man,v 1.1.1.1 2007-05-25 09:36:02 jick_nan Exp $".
.\"
