.\"
.\" "$Id: mime.types.man,v 1.1.1.1 2007-05-25 09:36:02 jick_nan Exp $"
.\"
.\"   mime.types man page for the Common UNIX Printing System (CUPS).
.\"
.\"   Copyright 1997-2002 by Easy Software Products.
.\"
.\"   These coded instructions, statements, and computer programs are the
.\"   property of Easy Software Products and are protected by Federal
.\"   copyright law.  Distribution and use rights are outlined in the file
.\"   "LICENSE.txt" which should have been included with this file.  If this
.\"   file is missing or damaged please contact Easy Software Products
.\"   at:
.\"
.\"       Attn: CUPS Licensing Information
.\"       Easy Software Products
.\"       44141 Airport View Drive, Suite 204
.\"       Hollywood, Maryland 20636-3111 USA
.\"
.\"       Voice: (301) 373-9603
.\"       EMail: cups-info@cups.org
.\"         WWW: http://www.cups.org
.\"
.TH mime.types 5 "Common UNIX Printing System" "22 June 2000" "Easy Software Products"
.SH NOM
mime.types \- Fichier de description des types MIME de CUPS
.SH DESCRIPTION
Le fichier \fImime.types\fR dfinit les types de fichier reconnus par CUPS.
.LP
D'autres types de fichiers peuvent tre ajouts au fichier \fImime.types\fR
ou  d'autres fichier dans le rpertoire \fB/etc/cups\fR. Ceux-ci doivent
porter l'extension \ .types\ .
.LP
Chaque ligne du fichier \fImime.types\fR est soit une rgle, soit
une ligne vide, soit un commentaire (ligne commenant par le caractre
#). Chaque ligne dfinissant une rgle commence par le nom du type MIME,
et peut tre suivi par une liste de rgle des reconnaissance utilises
pour dterminer le type du fichier\ :
.br
.nf

    super/type rgle [ ... rgleN]
.fi
Ces rgles doivent tre mises entre parenthses, lies par un "+" pour
exprimer un ET logique, "," ou une espace pour exprimer un OU logique.
Elles sont prcdes de "!" pour exprimer un NON logique.
.SH RGLES
Les rgles sont composes de deux parties\ : une extension de fichier et des
fonctions de tests entre parenthses. Les fonctions suivantes peuvent tre
utilises\ :
.TP 5
match("motif")
.br
Reconnaissance d'un motif sur le nom du fichier
.TP 5
ascii(dbut, longueur)
.br
Vrai si tous les octets de la portion de document sont des caractres ASCII
imprimables (CR, NL, TAB, BS, 32-126)
.TP 5
printable(dbut, longueur)
.br
Vrai si tous les octets de la portion de document sont des caractres 8 bits
imprimables (CR, NL, TAB, BS, 32-126, 128-254)
.TP 5
string(dbut, "chane")
.br
Vrai si les octets sont identiques  "chane"
.TP 5
char(dbut, valeur)
.br
Vrai si les octets sont identiques
.TP 5
short(dbut, valeur)
.br
Vrai si les nombres entiers (16 bits) sont identiques
.TP 5
int(dbut, valeur)
.br
Vrai si les nombres entiers (32 bits) sont identiques
.TP 5
locale("chane")
.br
Vrai si les dfinitions de langage sont identiques
.TP 5
contains(dbut, porte, "chane")
.br
Vrai si la chane est trouve dans la portion de document
.SH CHANES DE CARACTRES
Les chanes de caractres peuvent tre dfinies entre guillemets ("")
pour des chanes contenant des espaces ou entre crochets (<>) pour des
chanes en hexadcimal.
.SH VOIR AUSSI
classes.conf(5), cupsd(8), cupsd.conf(5), mime.convs(5), printers.conf(5),
CUPS Software Administrators Manual,
http://localhost:631/documentation.html
.SH COPYRIGHT
Copyright 1993-2002 Easy Software Products, Tous droits rservs.
.SH TRADUCTION
Gilles QUERRET <gilles.querret@nerim.net>
.\"
.\" End of "$Id: mime.types.man,v 1.1.1.1 2007-05-25 09:36:02 jick_nan Exp $".
.\"

